"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MQTTAuth = void 0;
const express_1 = require("express");
const MQTTAuth = (getUser, isValidResource) => {
    const router = (0, express_1.Router)();
    router.get('/auth/user', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
        console.log("Auth input", req.query);
        const userQuery = req.query;
        try {
            const userResp = yield getUser(userQuery.username, userQuery.password);
            const { allow: isAuthed, role } = typeof (userResp) === 'object' ? userResp : { allow: userResp, role: undefined };
            if (isAuthed) {
                console.log("Auth output true", req.query);
                res.send(`allow ${role ? role + ' ' : ''}device hive-command`);
            }
            else {
                console.log("Auth output false", req.query);
                res.send('deny');
            }
        }
        catch (e) {
            console.log("Auth output true", req.query, e);
            res.send('deny');
        }
    }));
    router.get('/auth/vhost', (req, res) => {
        res.send("allow");
    });
    router.get('/auth/resource', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
        const { username, name, permission } = req.query;
        console.log({ username, name, permission }, "Resource Req");
        try {
            const isValid = yield isValidResource(username, name, permission);
            if (name.indexOf('amq.') > -1 || isValid) {
                return res.send("allow");
            }
            else {
                console.log("Resources failed ", req.query);
            }
            console.log("Deny resource", name, name.indexOf('amq') > -1, name.match(/amq\..*/) != null);
            return res.send('allow');
        }
        catch (e) {
            console.error("Resource error", e);
            res.send('deny');
        }
    }));
    router.get('/auth/topic', (req, res) => {
        console.log({ query: req.query }, "Topic Req");
        res.send('allow');
    });
    return router;
};
exports.MQTTAuth = MQTTAuth;
